import java.net.*;
import java.io.*;
import java.util.*;

// The Server class implements a basic server that echos whatever file
// the client requests.
public class Server {
	// Port to use to connect with the client
	public static final int PORT = 1823;
	
	public static void main(String[] args) throws IOException, FileNotFoundException {
		// Start the server, allowing clients to connect
		ServerSocket serverSocket = new ServerSocket(PORT);
		
		for (;;) {
			// Wait for a client
			Socket clientSocket = serverSocket.accept();
			
			// Read in the HTTP header from the client's connection
			BufferedReader in = new BufferedReader(new
				InputStreamReader(clientSocket.getInputStream()));
			
			String line = in.readLine();
			String requestedFile = null;
			while (line != null) {
				// Echo the header to System.out
				System.out.println(line);
				
				// Get the requested file from the header
				if (line.startsWith("GET"))
					requestedFile = line.split("\\s+")[1].substring(1);
				if (line.isEmpty())
					break;
				line = in.readLine();
			}
			
			PrintWriter out = new
					PrintWriter(clientSocket.getOutputStream());
			out.println("Hello world! You requested " + requestedFile);
			
			// Print out the file to the client
			Scanner file = new Scanner(new File(requestedFile));
			while (file.hasNextLine())
				out.println(file.nextLine());
			
			// Clean up all our connections
			out.flush();
			out.close();
			in.close();
			clientSocket.close();
		}
	}
}